%{
  (* Header: everything betweeen %{ and %} is exported directly to the
     beginning of the generated .ml file *)
open Ast
%}

/* Begin grammatical specification */

/* Typically, we start by declaring tokens.  menhir uses the tokens to
   automatically generate a token datatype */
%token LPAREN
%token RPAREN
%token EOF


/* Declare "program" as the starting nonterminal of the grammar */
%start top

/* Type annotations for program */
%type <ast> top

%% /* Productions go here, after %% */

top:
  | xs=balanced_list EOF  { Node xs }

balanced_list:
  | x=balanced xs=balanced_list { x::xs }
  | x=balanced { [x] }

balanced:
  | LPAREN xs=balanced_list RPAREN { Node xs }
  | LPAREN RPAREN { Leaf }